#ifndef __CONN_H__
#define __CONN_H__

#define CONN_NONE      0
#define CONN_CONNECTED 1
#define CONN_IPV6      2
#define CONN_USEREMIP  4
#define CONN_USELOCIP  8
#define CONN_LISTEN    16
#define CONN_CHILD     32

#define BUFF_SIZE 2048

#include <proto.h>
#include <netdef.h>

#ifdef _REENTRANT
#include <pthread.h>
#endif

struct conn {
  int num;
  netnode near;
  netnode far;
  protocol *prot;
  int status;
  int flags;
  char buff[BUFF_SIZE];
  int fd;

#ifdef _REENTRANT
	int _locked;
	pthread_t _locked_thr;
	pthread_mutex_t _mutex;
#endif
};

typedef struct conn connection;

extern connection *get_connection(netnode, protocol*, int);
extern connection *new_connection(netnode, netnode, protocol*, int);
extern int connectout(connection *);
extern int connectin(connection *, int);
extern connection *accept_new(connection *);
extern int senddata(connection *, char *, int, int);
extern int recvdata(connection *, char *, int, int);
extern int disconnect(connection *);
extern int applyflag(connection *, int);
extern int poll_conn(connection *, int);
extern int isdisconnected(connection *);
extern int checkflag(connection *, int);

#endif
