#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <termios.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <netdef.h>
#include <proto.h>
#include <proto-file.h>

#ifdef DEBUG
#include <util.h>
#include <errno.h>
#endif

protocol filecomm = {
  "fileio",
  0,
  nullaccept,          /* I've realized that someone may have some generic
			  routine handler to auto call accept(). this is NOT
			  the right thing to do, but we'll accommodate it */
  filesend,
  filerecv,
  filecon,
  filediscon
};

int nullaccept(netnode n1, netnode n, int flags, netnode *g){
#ifdef DEBUG
  __util_debug_print("ERROR: accept() on a file connection is wrong.");
#endif
  return -1;
}

int filesend(netnode n1, netnode n2, int flags, char *data, int size){
  return write(n1.fd, data, size);
}

int filerecv(netnode n1, netnode n2, int flags, char *data, int size){
  return read(n1.fd, data, size);
}

/**
 */
int filecon(netnode n1, netnode n2, int flags){
  int fd;

  if(n1.host == NULL) return -2;

  fd = open(n1.host, O_RDWR);

  if (fd <0) return -1;

  /* we can now return */
  return fd;
}

int filediscon(netnode n1, netnode n2){
  return close(n1.fd);
}
